<?php
class StocksController extends AppController
{


	var $helpers = array("Form");

	var $uses = array("Stock", "User", "Acluserscsvstore", "Aclusersmanufacturer", "Csvproduct", "Round", "Stockcheck", "Closedround");

	var $paginate = array(
        'limit' => 10000,
        'order' => array(
            'Csvproduct.productcategory' => 'asc'
        )
    );
	
	function test() {
		//$a=0;
		echo "money: " . $this->parseMoney("");
		exit(0);
	}
	
	function amoverview($unsafeUserID=null, $unsafeCsvstoreID=null) {
		$userID = (int) $unsafeUserID;
		$csvstoreID = (int) $unsafeCsvstoreID;
		
		if ($userID>0 && $csvstoreID>0) {
			// accounty hat rep und markt ausgewhlt -> in die session schreiben
			// und /stocks/show aufrufen
			$this->smartSession('Global.selectedcsvstoreid', $csvstoreID, "doesntmatter");
			$this->smartSession('Global.selectedrep', $userID, "doesntmatter");
			$this->redirect( "/stocks/show"); 
			exit(0); // force redirect
		}
		
	
		if ($this->requireAccess(true, array("accountmanager"))) {
			$rounds = $this->Round->findAll("isEnabled='y' and ( uts_round_until<".time()." or Round.id=".$this->Round->getCurrentRoundID().")  order by uts_round_until asc" );
			$this->set(compact('rounds'));
			$selectedroundid = $this->smartSession('Global.selectedroundid', @$_REQUEST['selectedroundid'], $rounds[0]['Round']['id']);
			$this->set(compact('selectedroundid'));
			$currentroundid =$this->Round->getCurrentRoundID();
			$this->set(compact("currentroundid"));
			
			$utsRoundUntil = $this->Round->getUtsRoundUntil($rounds, $selectedroundid);
			
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("User.isEnabled='y' and user_id=" . $this->getLoggedInUserID(). " order by name asc"  );
			$this->set("assignedManufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers [0]['Manufacturer']['id']);
			$this->set(compact('selectedmanufacturerid'));
			

			
			$acluserscsvstores =  $this->Acluserscsvstore->findAll("User.isEnabled='y' order by User.last_name"  ); 
			// In Array $assignedcsvstores werden alle Stores gespeichert die, in der ausgewhlten Runde, einem Rep zugeteilt waren.
			$assignedcsvstores = $this->getAssignedCsvstores($acluserscsvstores, $utsRoundUntil);
			$this->set("assignedcsvstores", $assignedcsvstores);
			
			
			$assignedreps =  $this->Aclusersmanufacturer->findAll("User.isEnabled='y' and manufacturer_id=" . $selectedmanufacturerid );
			$this->set(compact("assignedreps"));
			$selectedrep = $this->smartSession('Global.selectedrep', @$_REQUEST['selectedrep'], $assignedreps [0]['User']['id']);
			
			$this->set(compact('selectedrep'));
			
			
			
			$repRoleID = $this->getRoleIdByKey("rep");
			$this->set(compact('repRoleID'));
			
		}
	}
	
	function show() {

		if ($this->requireAccess(true, array("accountmanager", "rep"))) {
			// https://ssl.langhofer.at/mantis/view.php?id=114
			// Es stehen alle Runden zur Auswahl, die noch nicht abgeschlossen wurden(siehe Neue GUI) und <= aktuelle Runde. 
			// 1. TODO: die noch nicht abgeschlossen wurden(siehe Neue GUI)
			// 2.  <= aktuelle Runde -> wird in view gelst,
			$rounds = $this->Round->findAll("isEnabled='y' and ( uts_round_until<".time()." or Round.id=".$this->Round->getCurrentRoundID().")  order by uts_round_until asc" );
			$this->set(compact('rounds'));
			$selectedroundid = $this->smartSession('Global.selectedroundid', @$_REQUEST['selectedroundid'], $rounds[0]['Round']['id']);
			$this->set(compact('selectedroundid'));
			$currentroundid =$this->Round->getCurrentRoundID();
			$this->set(compact("currentroundid"));
			
			$utsRoundUntil = $this->Round->getUtsRoundUntil($rounds, $selectedroundid);
			
			
			$aclusersmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=".$this->getLoggedInUserID()." order by name asc");
			
			// In Array $assignedmanufacturers werden alle Hersteller gespeichert die, in der ausgewhlten Runde, dem jeweiligen Rep zugeteilt waren.
			$assignedmanufacturers =  $this->getAssignedManufacturers($aclusersmanufacturers, $utsRoundUntil);
			$this->set("assignedManufacturers", $assignedmanufacturers);
			
			
			$selectedmanufacturerid = $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id'], 1, $this->extractIDs($assignedmanufacturers, "Manufacturer"));
			
			
			$this->set(compact('selectedmanufacturerid'));
			
			$loggedInRoleID = $this->getLoggedInRoleID();
			$this->set(compact('loggedInRoleID'));
			$amRoleID = $this->getRoleIdByKey("accountmanager");
			$this->set(compact('amRoleID'));
			
			$assignedreps =  $this->Aclusersmanufacturer->findAll("User.isEnabled='y' and manufacturer_id=" . $selectedmanufacturerid );
			$this->set(compact("assignedreps"));
			$selectedrep = $this->smartSession('Global.selectedrep', @$_REQUEST['selectedrep'], $assignedreps [0]['User']['id']);
			$this->set(compact('selectedrep'));
			
			if ($loggedInRoleID == $amRoleID) {
				// am ist eingelogged
				$user_id = $selectedrep;
			} else {
				// rep ist eingelogged, weil nur am und rep einloggen drfen und am nicht eingelogged ist
				$user_id = $this->getLoggedInUserID();
			}
			$acluserscsvstores =  $this->Acluserscsvstore->findAll("user_id=" . $user_id .  " order by uniqueExtID" );
			// In Array $assignedcsvstores werden alle Stores gespeichert die, in der ausgewhlten Runde, dem jeweiligen Rep zugeteilt waren.
			//print_r($acluserscsvstores);
			$assignedcsvstores = $this->getAssignedCsvstores($acluserscsvstores, $utsRoundUntil);
			$this->set("csvstores", $assignedcsvstores);
			
			//echo "before";
			//print_r($_SESSION);
			//print_r($assignedcsvstores);
			$selectedcsvstoreid = $this->smartSession('Global.selectedcsvstoreid', @$_REQUEST['selectedcsvstoreid'], $assignedcsvstores[0]['Csvstore']['id'], 1, $this->extractIDs($assignedcsvstores, "Csvstore"));
			//echo "after: " . $selectedcsvstoreid;
			//print_r($_SESSION);
			//exit(0);
			$this->set(compact('selectedcsvstoreid'));
			
			
			
			
			
			
			
			
			
			$selectedchain=$this->Acluserscsvstore->query("SELECT Chain.*
				FROM csvstores
				LEFT JOIN chains AS `Chain` ON Chain.id = csvstores.chain_id
				WHERE csvstores.id =".$selectedcsvstoreid);
			$this->set(compact('selectedchain'));
			
			
			
			
			// todo: Wann Produkte eingefgt wurden bercksichtigen insert_round_id
			$csvproducts = $this->paginate("Csvproduct", array("Csvproduct.isEnabled='y' and manufacturer_id= " .$selectedmanufacturerid));
			$this->set(compact("csvproducts"));
			
			
			
			
			
			if ($this->Closedround->isClosed($selectedroundid, $selectedmanufacturerid, $this->getLoggedInUserID())) {
				// runde bereits abgeschlossen, keine zahlungen mehr eingebbar
				$this->set("roundclosed", "Runde bereits abgeschlossen");
			} else {
				if (isset($this->params["form"]["button"])) {
	//print_r($this->data);
					$readies=array();
					$errors=array();
					
					// schleife ber alle eingaben in der gui
					foreach ($this->params["data"]["Csvproducts"] as $csvproduct_id => $stockcheck) {
						
						// passt der preis?
						/*
						if ( 
							(!isset($stockcheck["Stockcheck"]["retail_price"]) ||
							$stockcheck["Stockcheck"]["retail_price"] == "")
								&&
							(($stockcheck["Stockcheck"]["comment"]) == ""
							)
							
							) {
							// keine daten in dieser zeile eingegeben, der preis oder der kommentar ist ein pflichtfeld!
							//echo "not set";
							//echo $csvproduct_id . " -> skip<br>";
							continue;
							
						}
						*/
						




						// ******** wurden tatschlich 3 werte je > 0 oder ein kommentar eingegeben?  ****************
						$shouldBeChecked="";
						foreach ($csvproducts as $csvproduct) {
							if ($csvproduct["Csvproduct"]["id"] == $csvproduct_id) {
								// found
								$shouldBeChecked=$csvproduct["Csvproduct"]["shouldBeChecked"];
								break;
							}
						}
						if ($shouldBeChecked=="n") {
							if ( trim($stockcheck["Stockcheck"]["comment"]) == "" &&
								(int)$stockcheck["Stockcheck"]["retail_price"]<=0 && 
								(int)$stockcheck["Stockcheck"]["quantity"]<=0 &&
								(int)$stockcheck["Stockcheck"]["stock"]<=0
							  ) {
								// diese eingegebene zeile (also diese lagerstandsberprufng) ignorieren
								continue;
							}
						}
						// ******** wurden tatschlich 3 werte je > 0 oder ein kommentar eingegeben?  ****************



						
					
						// zuerst wird in der db das produkt gelscht (falls vorhanden) und dann geinserted
						// daher machen wir IMMER einen insert und nie ein UPDATE statement
						$stockcheck["Stockcheck"]["id"]=0; // damit wird a insert statemen und ka update statement gebaut
						$stockcheck["Stockcheck"]["csvproduct_id"]=$csvproduct_id;
						$stockcheck["Stockcheck"]["uts_inserted"]=time();
						$stockcheck["Stockcheck"]["ip"]=$_SERVER['REMOTE_ADDR'];
						$stockcheck["Stockcheck"]["user_id"]=$user_id; // id vom rep, auch wenn der am formular ausgefllt hat
						$stockcheck["Stockcheck"]["csvstore_id"]=$selectedcsvstoreid;
						$stockcheck["Stockcheck"]["round_id"]=$selectedroundid;
						$stockcheck["Stockcheck"]["retail_price"]=$this->parseMoney($stockcheck["Stockcheck"]["retail_price"]);
						$stockcheck["Stockcheck"]["quantity"]=(int)$stockcheck["Stockcheck"]["quantity"]; // bani will unbedingt ints fr stock, ich htts ja anders gemacht
						$stockcheck["Stockcheck"]["comment"] = trim($stockcheck["Stockcheck"]["comment"]);
						//print_r($stockcheck);
						
						$this->Stockcheck->set( $stockcheck );
	
	
	//echo $csvproduct_id . "-> " .$stockcheck["Stockcheck"]["comment"];
						if ( $stockcheck["Stockcheck"]["comment"] != "" ) {
							// mit kommentar ist jeder eintrag in die db zu schreiben
							array_push($readies, $stockcheck);
						} elseif( $this->Stockcheck->validates() ) {
							array_push($readies, $stockcheck);
						} else {
							// could not validate data
							//$errors[$csvproduct_id]=array();
							$err = $this->Stockcheck->invalidFields();
							//echo "<b>product: " . $csvproduct_id . "</b>";
							//echo "<pre>";
							//print_r($err);
							//echo "</pre>";
							$errors[$csvproduct_id]=array();
							$errors[$csvproduct_id]=$err;
							//echo "<pre>";
							//print_r($errors);
							//echo "</pre>";
							$this->set(compact("errors"));
							
						}
						
					}	
					if (sizeof($errors)>0) {
						// es hat fehler gegeben, nichts speichern
						$this->Session->setFlash('<div class="error-message-new"><img src="/img/cross_icon_small.png" alt="Cross Icon" /> Nicht alle zu &uuml;berpr&uuml;fenden Produkte wurden eingegeben.</div>');
					} else {
						// alle eingaben sind gltig, speichern!
						//print_r($readies);
						
						foreach ($readies as $ready) {
						
							// falls eintrag schon in db ist lschen
							$query="delete from stockchecks where round_id=".$ready["Stockcheck"]["round_id"]." and csvproduct_id=".$ready["Stockcheck"]["csvproduct_id"] ." and csvstore_id=".$ready["Stockcheck"]["csvstore_id"]." and user_id=" . $ready["Stockcheck"]["user_id"];
							
							
							//exit(0);
							$this->Stockcheck->query($query);
							if ($this->Stockcheck->save($ready)) {
								
								$this->Session->setFlash('<div class="success-message"><img src="/img/hook_icon_small.png" alt="Hook Icon" /> Bestandsliste konnte erfolgreich gespeichert werden.</div>');
							} else {
								$this->flash("Datenbankfehler! Bitte probieren Sie es zu einem spteren Zeitpunkt erneut", "/stocks/show");
							}
						}
						// damit man nicht mit nem browser reload nochmal die datenstze einfgt sondern sauber zurckgeleitet wird
						$this->redirect( "/stocks/show"); 
					}				
						
					
					
					
				}
			}
			
			
			$stockchecks = $this->Stockcheck->findAll("round_id=" .$selectedroundid . " and user_id=". $user_id ." and csvstore_id=".$selectedcsvstoreid);
			$this->set(compact("stockchecks")); 
			
			
			
		}
	}
}
?>
