<?php
class Payment extends AppModel
{
    var $name = 'Payment';
	
	
	var $belongsTo= array(
		'Manufacturer' =>
		array('className'    => 'Manufacturer',
			  'conditions'   => '',
			  'order'        => '',
			  'foreignKey'   => 'manufacturer_id'
		),
							
		'Csvstore' =>
		array(
			  'className'    => 'Csvstore',
			  'conditions'   => '',
			  'order'        => '',
			  'foreignKey'   => 'csvstore_id'
		),

		'Paymenttype' =>
		array('className'    => 'Paymenttype',
			  'conditions'   => '',
			  'order'        => '',
			  'foreignKey'   => 'paymenttype_id'
		),
		
		'Roundfrom' =>
		array('className'    => 'Round',
			  'conditions'   => '',
			  'order'        => '',
			  'foreignKey'   => 'payment_from_round_id'
		),
		
		'Rounduntil' =>
		array('className'    => 'Round',
			  'conditions'   => '',
			  'order'        => '',
			  'foreignKey'   => 'payment_until_round_id'
		),
							

	);
	
	var $validate = array(
        'amount' => array(
            'rule' => array('custom', '/^[0-9]{0,}[\.]{0,1}[0-9]{0,2}$/'), 
            'message' => 'Bitte geben Sie hier einen Betrag in einem der Formate ein.<br />Beispiele: <br />198<br />12<br />23.4<br />56.78'
		),
        'rackwidth' => array(
            'rule' => array('custom', '/^[0-9]{0,}[\.]{0,1}[0-9]{0,}$/'), 
            'message' => 'Bitte geben Sie hier die Regalbreite in Metern ein.<br />Beispiele: <br />198<br />12<br />23.4<br />56.5'
		),

    );
	
	
	
	
	
	
	
	
	/*
		liefert ein array aller berlappenden runden fr eine gegebene zahlung
	
		aktuelle "zahlung":
		---|--|-------|XXXXXXXXXXX|-----|----|-------
	
		Check if runde rein/ber- lappend:
		
		1. fall (runde hrt whrend zahlungszeitraum auf)
		---|--|XXXXXXXXXXX|-|-----------|----|-------
		oder
		2. fall (runde beginnt whrend zahlungszeitraum)
		---|----------------|XXXXXXXXXXX|----|-------
		oder
		3.fall (runde fngt vor zahlungszeitraum an und hrt nach zahlungszeitraum auf)
		---|XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX|-------

	*/
	function getInRounds($allrounds, $uts_payment_from, $uts_payment_until) {
		$ret=array();
		//print_r($allrounds);
		foreach ($allrounds as $allround) {
			$uts_round_from = $allround["Round"]["uts_round_from"];
			$uts_round_until = $allround["Round"]["uts_round_until"];
			
			//echo "uts_round_from: " . $uts_round_from . "\n";
			//echo "uts_round_until: " . $uts_round_until . "\n";
			
			if (	$uts_round_until >$uts_payment_from &&	$uts_round_until<$uts_payment_until ||
					$uts_round_from >$uts_payment_from 	&& 	$uts_round_from<$uts_payment_until 	||
					$uts_round_from<$uts_payment_from 	&& 	$uts_round_until>$uts_payment_until
				) {
				array_push($ret, $allround["Round"]["id"]);
			}
			
		}
		//echo "zahlung: " . date("d.m.Y H:i:s", $uts_payment_from) ."-". date("d.m.Y H:i:s", $uts_payment_until) . " liegt in den runden: ";
		//print_r($ret);
		
		return $ret;
	}
	
	
	// wie function getInRounds()  nur gibt man statt uts round_ids an
	/* untested, ka ob das funktioniert?=)
	function getPaymentsforRound($allrounds, $round_id) {
		$round = $this->Round->find("Round.isEnabled='y' and Round.id=".$round_id);

		$uts_payment_from = $round["Round"]["uts_round_from"];
		$uts_payment_until = $round["Round"]["uts_round_until"];

		$allrounds = $this->Round->findAll("Round.isEnabled='y'");


		return  getInRounds($allrounds, $uts_payment_from, $uts_payment_until);
	}
	*/
	
	
	//TODO: funktion unvollstndig
	function get($allroundsSortedByUntilDateAsc) {
	
		$payments  = $this->findAll("Payment.isEnabled='y'");
		$ret = array();
		foreach ($allroundsSortedByUntilDateAsc as $round) {
		
			foreach ($payments as $payment) {
			
				if ($payment["Payment"]["payment_until_round_id"] <= $round["Round"]["id"]) {
					// zahlung endet vor oder mit rundenende in diesem schleifendurchgang
					if ($payment["Payment"]["payment_from_round_id"] >= $round["Round"]["id"]) {
					}
					
				}
				
			}
		
//			$ret[$round["Round"]["id"]] = 
		}
	
	}
	
	
	// callback wird von cakephp ausgelst, see http://book.cakephp.org/view/76/Callback-Methods
	/*
	function afterFind($results, $primary) {
		
		//
		
		//$allrounds = $this->query("select * from rounds");
		
		$roundModel = new Round();
		$allrounds = $roundModel->findAll();
	//print_r($allrounds);
	
		foreach ($results as $key => $value) {
			if (isset($value["Payment"])) {
				$results[$key]["inRound"] = $this->getInRounds($allrounds, $value["Payment"]["uts_payment_from"], $value["Payment"]["uts_payment_until"]);
			}
		}
		
		
		
		return $results;
	}
	*/
}
?>